c
      SUBROUTINE MESSNB(NUMBER,ITEXT,ISTOP)
      CHARACTER *8 ITEXT, CC*36
      IF (ISTOP.EQ.1) THEN
C
C Error exit from R
C
       CC='Input parameter error(s) in '//ITEXT
       CALL REXIT(CC)
      ELSE
       CC=ITEXT//': warning no'
       CALL INTPR(CC,18,NUMBER,1)
      ENDIF
      RETURN
      END
C
C-------------------------------------------------------------------------------
C
      SUBROUTINE FTITP1(MUAL,TAB,L1,L2,M1,M2,ALG,KA,MUG,KM,INTER)
      implicit double precision (a-h,o,q-z)
c     implicit integer (i-n,p)
      double precision TAB(KA,KM),MUAL(2),ALG(KA),MUG(KM),INTER
C       
      F11=TAB(L1,M1)
      F21=TAB(L2,M1)
      F12=TAB(L1,M2)
      F22=TAB(L2,M2)
      X = MUAL(2)
      Y = MUAL(1) 
      X1= ALG(L1)
      X2= ALG(L2)
      Y1= MUG(M1)
      Y2= MUG(M2)
      D = (X2-X1)*(Y2-Y1)
      INTER =  F11*(X2-X)*(Y2-Y)+F21*(X-X1)*(Y2-Y)+F12*(X2-X)*(Y-Y1) + 
     +         F22*(X-X1)*(Y-Y1)

      IF (D.NE.0) INTER = INTER/D

      IF (L1.EQ.L2.AND.M1.NE.M2) INTER=F11+(F1 -F11)/(Y2-Y1)*(Y-Y1)

      IF (L1.NE.L2.AND.M1.EQ.M2) INTER=F11+(F21-F11)/(X2-X1)*(X-X1)

      IF (L1.EQ.L2.AND.M1.EQ.M2) INTER = F11       
      RETURN
      END
C
C------------------------------------------------------------------------------
C
      SUBROUTINE FTITAAB(MUAL,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,
     +    TABB,TABA11,TABA12,TABA21,TABA22,TABA1,TABA2,B,AA,A,IERR)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      double precision MUAL(2),MU1,MU2,ALG(KA),MUG(KM),AA(2,2),A(2),
     +       TABB(KA,KM),TABA11(KA,KM),TABA12(KA,KM),TABA21(KA,KM),
     +       TABA22(KA,KM),TABA1(KA,KM),TABA2(KA,KM)

c alpha1 = TabAab$alpha1
c alpha2 = TabAab$alpha2
c mu1    = TabAab$mu1
c mu2    = TabAab$mu2
c ka     = TabAab$ka
c km     = TabAab$km
c alg    = seq(from=alpha1,to=alpha2,length=ka)
c mug    = seq(from=mu1,   to=mu2,   length=km)
      IERR=0
      if (mual(2).LT.alpha1) THEN
         l1 =  1
         l2 =  1
 		 IERR=1
c        cat("alpha <= lower limit:",mual[2], "\n")}
      ENDIF
      if (mual(2).GT.alpha2) THEN
         l1 = ka
         l2 = ka
 		 IERR=2
c        cat("alpha >= upper limit:",mual[2], "\n")}
       ENDIF
       if (alpha1.LE.mual(2).AND.mual(2).LE.alpha2) THEN
         l1  = INT(FLOAT(ka-1)*(mual(2) - alpha1)/(alpha2-alpha1)) + 1
         l2  = l1+1
       ENDIF
       if (mual(1).LT.mu1) THEN
         m1 = 1
         m2 = 1
		 IERR=3
c        cat("mu <= lower limit:",mual[1], "\n")}
       ENDIF
       if (mual(1).GT.mu2) THEN
         m1 = km
         m2 = km
		 IERR=4
c        cat("mu >= upper limit:",mual[1], "\n")}
       ENDIF
       if (mu1.LE.mual(1).AND.mual(1).LE.mu2)THEN   
         m1 = INT(DFLOAT(km-1)*(mual(1) - mu1)/(mu2 - mu1)) + 1
         m2 = m1+1
       ENDIF
       CALL FTITP1(mual,Tabb,l1,l2,m1,m2,alg,ka,mug,km,b)
       CALL FTITP1(mual,TabA11,l1,l2,m1,m2,alg,ka,mug,km,AA(1,1))    
       CALL FTITP1(mual,TabA12,l1,l2,m1,m2,alg,ka,mug,km,AA(1,2))  
       CALL FTITP1(mual,TabA21,l1,l2,m1,m2,alg,ka,mug,km,AA(2,1))
       CALL FTITP1(mual,TabA22,l1,l2,m1,m2,alg,ka,mug,km,AA(2,2))
       CALL FTITP1(mual,Taba1,l1,l2,m1,m2,alg,ka,mug,km,a(1))
       CALL FTITP1(mual,Taba2,l1,l2,m1,m2,alg,ka,mug,km,a(2))
C      A=matrix(c(A11,A12,A21,A22),ncol=2,byrow=T)
C      a=c(a1,a2)
C      list(b=b,A=A,a=a)
      RETURN
      END
C
C-------------------------------------------------------------------------------
C
      SUBROUTINE FTITAABN(MUAL,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,
     +           TABB,TABA11,TABA12,TABA21,TABA22,TABA1,TABA2,
     +           B,B1,B2,AA,AL,AH,A,A1,A2,MULOW,MUHIGH,IERR)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      double precision MUAL(2),MU1,MU2,ALG(KA),MUG(KM),AA(2,2),
     + AL(2,2),AH(2,2),A(2),A1(2),A2(2),MUALL(2),MUALH(2),MULOW,
     + MUHIGH,TABB(KA,KM),TABA11(KA,KM),TABA12(KA,KM),TABA21(KA,KM),
     + TABA22(KA,KM),TABA1(KA,KM),TABA2(KA,KM)

c alpha1 = TabAab$alpha1
c alpha2 = TabAab$alpha2
c mu1    = TabAab$mu1
c mu2    = TabAab$mu2
c ka     = TabAab$ka
c km     = TabAab$km
c alg    = seq(from=alpha1,to=alpha2,length=ka)
c mug    = seq(from=mu1,   to=mu2,   length=km)
      IERR=0
      IF (mual(2).LT.alpha1) THEN
         l1 =  1
         l2 =  1
c        CALL MESSNB(401,'FITPAABN',0)
         IERR=1		 
c        cat("alpha <= lower limit:",mual[2], "\n")}
      ENDIF
      if (mual(2).GT.alpha2) THEN
         l1 = ka
         l2 = ka
c        CALL MESSNB(402,'FTITAABN',0)
         IERR=2		 
c        cat("alpha >= upper limit:",mual[2], "\n")}
      ENDIF
      IF (alpha1.LE.mual(2).AND.mual(2).LE.alpha2) THEN
         l1  = INT(FLOAT(ka-1)*(mual(2) - alpha1)/(alpha2-alpha1)) + 1
         l2  = l1+1
      ENDIF
      IF (mual(1).LT.mu1) THEN
         m1 = 1
         m2 = 1
c        CALL MESSNB(403,'FTITAABN',0)
         IERR=3		 
c        cat("mu <= lower limit:",mual[1], "\n")}
      ENDIF
      if (mual(1).GT.mu2) THEN
         m1 = km
         m2 = km
c        CALL MESSNB(404,'FTITAABN',0)
         IERR=4		 
c        cat("mu >= upper limit:",mual[1], "\n")}
      ENDIF
      IF (mu1.LE.mual(1).AND.mual(1).LE.mu2)THEN   
         m1 = INT(FLOAT(km-1)*(mual(1) - mu1)/(mu2 - mu1)) + 1
         m2 = m1+1
      ENDIF
      CALL FTITP1(mual,Tabb,l1,l2,m1,m2,alg,ka,mug,km,b)
      CALL FTITP1(mual,TabA11,l1,l2,m1,m2,alg,ka,mug,km,AA(1,1))
      CALL FTITP1(mual,TabA12,l1,l2,m1,m2,alg,ka,mug,km,AA(1,2))
      CALL FTITP1(mual,TabA21,l1,l2,m1,m2,alg,ka,mug,km,AA(2,1))
      CALL FTITP1(mual,TabA22,l1,l2,m1,m2,alg,ka,mug,km,AA(2,2))
      CALL FTITP1(mual,Taba1,l1,l2,m1,m2,alg,ka,mug,km,a(1))
      CALL FTITP1(mual,Taba2,l1,l2,m1,m2,alg,ka,mug,km,a(2))

c      A<-matrix(c(A11,A12,A21,A22),ncol=2,byrow=T)
c      a<-c(a1,a2)

        IF (M2.EQ.1) M2=2
        IF (M1.EQ.KM) M1=KM-1
        MUALL(1)=MUG(M1)
        MUALL(2)=MUAL(2)
        MUALH(1)=MUG(M2)
        MUALH(2)=MUAL(2)
      CALL FTITP1(muall,Tabb,l1,l2,m1,m2,alg,ka,mug,km,b1)
      CALL FTITP1(muall,TabA11,l1,l2,m1,m2,alg,ka,mug,km,AL(1,1))
      CALL FTITP1(muall,TabA12,l1,l2,m1,m2,alg,ka,mug,km,AL(1,2))
      CALL FTITP1(muall,TabA21,l1,l2,m1,m2,alg,ka,mug,km,AL(2,1))
      CALL FTITP1(muall,TabA22,l1,l2,m1,m2,alg,ka,mug,km,AL(2,2))
      CALL FTITP1(muall,Taba1,l1,l2,m1,m2,alg,ka,mug,km,a1(1))
      CALL FTITP1( muall,Taba2,l1,l2,m1,m2,alg,ka,mug,km,a1(2))

c      Al<-matrix(c(A11l,A12l,A21l,A22l),ncol=2,byrow=T)
c      al<-c(a1l,a2l)

      CALL FTITP1(mualh,Tabb,l1,l2,m1,m2,alg,ka,mug,km,b2)
      CALL FTITP1(mualh,TabA11,l1,l2,m1,m2,alg,ka,mug,km,AH(1,1))
      CALL FTITP1(mualh,TabA12,l1,l2,m1,m2,alg,ka,mug,km,AH(1,2))
      CALL FTITP1(mualh,TabA21,l1,l2,m1,m2,alg,ka,mug,km,AH(2,1))
      CALL FTITP1(mualh,TabA22,l1,l2,m1,m2,alg,ka,mug,km,AH(2,2))
      CALL FTITP1(mualh,Taba1,l1,l2,m1,m2,alg,ka,mug,km,a2(1))
      CALL FTITP1(mualh,Taba2,l1,l2,m1,m2,alg,ka,mug,km,a2(2))

c      Ah<-matrix(c(A11h,A12h,A21h,A22h),ncol=2,byrow=T)
c      ah<-c(a1h,a2h)
       MULOW=MUG(m1)
       MUHIGH=MUG(m2)
c      list(b=b,A=A,a=a,bl=bl,Al=Al,al=al,bh=bh,Ah=Ah,ah=ah,mulow=mug[m1],muhigh=mug[m2])
       RETURN
       END
C
      SUBROUTINE EQALPHA(ALPHA,Y,MUNIX,IND,N,NU,ALPHA1,ALPHA2,MU1,MU2,
     +           ALG,KA,MUG,KM,TABB,TABA11,TABA12,TABA21,TABA22,
     +           TABA1,TABA2,WEIX,EQ3,MWRN,IERR)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      DOUBLE PRECISION MUX,MU1,MU2,ALG(KA),MUG(KM),Y(N),MUNIX(NU),
     +     TABB(KA,KM),TABA11(KA,KM),TABA12(KA,KM),TABA21(KA,KM),
     +     TABA22(KA,KM),TABA1(KA,KM),TABA2(KA,KM),WEIX(N),MUAL(2),
     +     Z(1,2),AA0(2,2),A0(2)
      DIMENSION AA(2,2,NU),A(2,NU),B(NU)   
      INTEGER IND(N)
C
c     alpha1 = TabAab$alpha1
c     alpha2 = TabAab$alpha2
c     mu1    = TabAab$mu1
c     mu2    = TabAab$mu2
c     ka     = TabAab$ka
c     km     = TabAab$km
c     alg    = seq(from=alpha1,to=alpha2,length=ka)
c     mug    = seq(from=mu1,   to=mu2,   length=km)
      NERR=0
      eps=4.930381d-32
      MUAL(2)=ALPHA 
      DO 100 I=1,NU
      MUAL(1)=MUNIX(I)
      CALL FTITAAB(MUAL,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,TABB,
     +     TABA11,TABA12,TABA21,TABA22,TABA1,TABA2,B0,AA0,A0,IERR)
	  NERR=MAX0(NERR,IERR)
      B(I)=B0
      AA(1,1,I)=AA0(1,1)
      AA(1,2,I)=AA0(1,2)
      AA(2,1,I)=AA0(2,1)
      AA(2,2,I)=AA0(2,2)
      A(1,I)=A0(1)
      A(2,I)=A0(2)
 100  CONTINUE
      EQ3=0.D0
      DO 300 I=1,N
      J=IND(I)
      MUX=MUNIX(J)
      CALL sB1(y(i),1,mux,alpha,Z,1,eps)
      z1 = AA(1,1,J)*(Z(1,1)-A(1,J)) + AA(1,2,J)*(Z(1,2)-A(2,J))
      z2 = AA(2,1,J)*(Z(1,1)-A(1,J)) + AA(2,2,J)*(Z(1,2)-A(2,J))
      D = DSQRT(z1*z1 + z2*z2)
      WX=DMIN1(1.D0,B(J)/D)
      EQ3=EQ3+WX*WEIX(I)*(Z(1,2)-A(2,J))
 300  CONTINUE
      IF (MWRN*NERR.NE.0) CALL MESSNB(400+NERR,'FTITAAB ',0)
      RETURN
      END
C
      SUBROUTINE MEQALPHA(ALPHA,Y,MUNIX,IND,N,NU,ALPHA1,ALPHA2,MU1,MU2,
     +           ALG,KA,MUG,KM,TABB,TABA11,TABA12,TABA21,TABA22,
     +           TABA1,TABA2,WEIX,EQ3)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      DOUBLE PRECISION MUX,MU1,MU2,ALG(KA),MUG(KM),Y(N),MUNIX(NU),
     +     TABB(NU),TABA11(NU),TABA12(NU),TABA21(NU),
     +     TABA22(NU),TABA1(NU),TABA2(NU),WEIX(N),Z(1,2)
c    +    ,MUAL(2),AA0(2,2),A0(2)
      DIMENSION AA(2,2,NU),A(2,NU),B(NU)   
      INTEGER IND(N)
C
c     alpha1 = TabAab$alpha1
c     alpha2 = TabAab$alpha2
c     mu1    = TabAab$mu1
c     mu2    = TabAab$mu2
c     ka     = TabAab$ka
c     km     = TabAab$km
c     alg    = seq(from=alpha1,to=alpha2,length=ka)
c     mug    = seq(from=mu1,   to=mu2,   length=km)
c      NERR=0
      eps=4.930381d-32
c     MUAL(2)=ALPHA 
      DO 100 I=1,NU
c      MUAL(1)=MUNIX(I)
c      CALL FTITAAB(MUAL,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,TABB,
c     +     TABA11,TABA12,TABA21,TABA22,TABA1,TABA2,B0,AA0,A0,IERR)
c
      B(I)=TABB(I)
      AA(1,1,I)=TABA11(I)
      AA(1,2,I)=TABA12(I)
      AA(2,1,I)=TABA21(I)
      AA(2,2,I)=TABA22(I)
      A(1,I)=TABA1(I)
      A(2,I)=TABA2(I)
  100 CONTINUE
      EQ3=0.D0
      DO 300 I=1,N
      J=IND(I)
      MUX=MUNIX(J)
      CALL sB1(y(i),1,mux,alpha,Z,1,eps)
      z1 = AA(1,1,J)*(Z(1,1)-A(1,J)) + AA(1,2,J)*(Z(1,2)-A(2,J))
      z2 = AA(2,1,J)*(Z(1,1)-A(1,J)) + AA(2,2,J)*(Z(1,2)-A(2,J))
      D = DSQRT(z1*z1 + z2*z2)
      WX=DMIN1(1.D0,B(J)/D)
      EQ3=EQ3+WX*WEIX(I)*(Z(1,2)-A(2,J))
 300  CONTINUE
c     IF (NERR.NE.0) CALL MESSNB(400+NERR,'FTITAAB ',0)
      RETURN
      END
C
      SUBROUTINE EQALFAML(ALPHA,Y,MUNIX,IND,N,NU,EQ3)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      DOUBLE PRECISION MUX,Y(N),MUNIX(NU),Z(1,2)
      INTEGER IND(N)
C
      eps=4.930381d-32
      EQ3=0.D0
      DO 300 I=1,N
      J=IND(I)
      MUX=MUNIX(J)
      CALL sB1(y(i),1,mux,alpha,Z,1,eps)
      EQ3=EQ3+Z(1,2)
 300  CONTINUE
      RETURN
	  END
C
      SUBROUTINE RGFLEQ3(CC,LOWER,UPPER,NINT,TOL,MAXIT,Y,MUNIX,IND,
     +        N,NU,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,TABB,TABA11,
     +        TABA12,TABA21,TABA22,TABA1,TABA2,WEIX,MWRN,SOL,NIT)         
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
c
      DOUBLE PRECISION LOWER,MUAL(2),MU1,MU2,ALG(KA),MUG(KM),Y(N),
     +     MUNIX(NU),PAS,TABB(KA,KM),TABA11(KA,KM),TABA12(KA,KM),
     +     TABA21(KA,KM),TABA22(KA,KM),TABA1(KA,KM),TABA2(KA,KM),
     +     WEIX(N),AA(2,2),A(2) 
      INTEGER IND(N)
C
C  INITIALIZE
C
      TL=DMIN1(1.D-10,0.1D0*TOL)
      NIT=0
	  NERR=0
      AS1=LOWER
      PAS=(UPPER-LOWER)/DFLOAT(NINT-1)
      CALL EQALPHA(AS1,Y,MUNIX,IND,N,NU,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,
     +           MUG,KM,TABB,TABA11,TABA12,TABA21,TABA22,TABA1,
     +           TABA2,WEIX,EQ3,MWRN,IERR)
	  IF (IERR.NE.0) NERR=NERR+1
      FAS1=EQ3-CC
      DO 100 I=1,NINT-1
      AS2=AS1+PAS
      CALL EQALPHA(AS2,Y,MUNIX,IND,N,NU,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,
     +           MUG,KM,TABB,TABA11,TABA12,TABA21,TABA22,TABA1,
     +           TABA2,WEIX,EQ3,MWRN,IERR)
	  IF (IERR.NE.0) NERR=NERR+1
      FAS2=EQ3-CC
      IF (FAS1*FAS2.LE.0.D0) GOTO 30
      AS1=AS2
      FAS1=FAS2
  100 CONTINUE
  999 IF (MWRN.EQ.1) CALL MESSNB(499,'RGFLEQ3 ',0)
      SOL= -999.D0 
      NIT= -1
      RETURN
C
C  REGULA FALSI ITERATION
C
   30 CONTINUE
      IF (FAS1.EQ.FAS2) GOTO 999
      XN=(AS1*FAS2-AS2*FAS1)/(FAS2-FAS1)
      CALL EQALPHA(XN,Y,MUNIX,IND,N,NU,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,
     +           MUG,KM,TABB,TABA11,TABA12,TABA21,TABA22,TABA1,
     +           TABA2,WEIX,EQ3,MWRN,IERR)
      FXN=EQ3-CC
	  IF (IERR.NE.0) NERR=NERR+1
C
C  TEST IF ROOT HAS BEEN FOUND
C
      IF (DABS(FXN).LT.TOL) GOTO 70
C
C  TEST IF MAXIMUM NUMBER OF ITERATIONS HAS BEEN REACHED
C
      IF (NIT.GE.MAXIT) GOTO 60
c	  VAL(1)=AS1
c	  VAL(2)=AS2
c	  VAL(3)=FAS1
c	  VAL(4)=FAS2
c	  VAL(5)=XN
c	  VAL(6)=FXN
c	  CALL DBLEPR('EQALFA',6,VAL,6)
      IF (FAS1*FXN.LE.0.D0) GOTO 40
      AS1=XN
      FAS1=FXN
      GOTO 50
   40 AS2=XN
      FAS2=FXN
C
C  INCREMENT ITERATION COUNTER AND GO TO NEXT ITERATION
C
   50 NIT=NIT+1
      IF (NERR.GT.2*NINT) GOTO 999
      GOTO 30
C
   60 ITERM=2
      IF (MWRN.EQ.1) CALL MESSNB(402,'RGFLEQ3 ',0)
      SOL=XN
      RETURN
   70 ITERM=1
      SOL=XN
      RETURN
      END
C
      SUBROUTINE RGFLEQML(CC,LOWER,UPPER,NINT,TOL,MAXIT,Y,MUNIX,IND,
     +           N,NU,SOL,NIT)         
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
c
      DOUBLE PRECISION LOWER,Y(N),MUNIX(NU),PAS  
      INTEGER IND(N)
C
C  INITIALIZE
C
      TL=DMIN1(1.D-10,0.1D0*TOL)
      NIT=0
      AS1=LOWER
      PAS=(UPPER-LOWER)/DFLOAT(NINT-1)
      CALL EQALFAML(AS1,Y,MUNIX,IND,N,NU,EQ3)
      FAS1=EQ3-CC
      DO 100 I=1,NINT-1
      AS2=AS1+PAS
      CALL EQALFAML(AS2,Y,MUNIX,IND,N,NU,EQ3)
      FAS2=EQ3-CC
      IF (FAS1*FAS2.LE.0.D0) GOTO 30
      AS1=AS2
      FAS1=FAS2
  100 CONTINUE
  999 CALL MESSNB(499,'RGFLEQML',0)
      SOL= -999.D0 
      NIT= -1
      RETURN
C
C  REGULA FALSI ITERATION
C
   30 CONTINUE
      XN=(AS1*FAS2-AS2*FAS1)/(FAS2-FAS1)
      CALL EQALFAML(XN,Y,MUNIX,IND,N,NU,EQ3)
      FXN=EQ3-CC
C
C  TEST TO SEE IF MAXIMUM NUMBER OF ITERATIONS HAS BEEN EXECUTED
C
      IF (NIT.GE.MAXIT) GOTO 60
C
C  TEST TO SEE IF ROOT HAS BEEN FOUND
C
      IF (DABS(FXN).LT.TOL) GOTO 70
      IF (FAS1*FXN.LE.0.D0) GOTO 40
      AS1=XN
      FAS1=FXN
      GOTO 50
   40 AS2=XN
      FAS2=FXN
C
C  INCREMENT ITERATION COUNTER
C
   50 NIT=NIT+1
      GOTO 30
C
   60 ITERM=2
      CALL MESSNB(402,'RGFLEQML',0)
      SOL=XN
      RETURN
   70 ITERM=1
      SOL=XN
      RETURN
      END
C
      SUBROUTINE EQ1EQ2(ALPHA0,X,Y,MUNIX,HPUNIX,HPPUNIX,IND,N,NU,
     +           ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,TABB,TABA11,
     +           TABA12,TABA21,TABA22,TABA1,TABA2,WEIX,WX,MUX,HPX,
     +           HPPX,A1X,A1PX,WPX,EQ1,EQ2,MWRN,IERR)
      implicit double precision (a-h,o,q-z)
      implicit integer (i-n,p)
 
      DOUBLE PRECISION MUI,MU1,MU2,ALG(KA),MUG(KM),X(N),Y(N),MUNIX(NU),
     +       HPUNIX(NU),HPPUNIX(NU),TABB(KA,KM),TABA11(KA,KM),
     +       TABA12(KA,KM),TABA21(KA,KM),TABA22(KA,KM),TABA1(KA,KM),
     +       TABA2(KA,KM),WEIX(N),WX(N),MUX(N),HPX(N),HPPX(N),A1X(N),
     +       A1PX(N),WPX(N),Z(1,2),ZZ(1,2),MUAL(2),AA0(2,2),AL0(2,2),
     +       AH0(2,2),A0(2),A0L(2),A0H(2),MULOW,MUHIGH,INTABMU
      DIMENSION AA(2,2,NU),AL(2,2,NU),AH(2,2,NU),A(2,NU),A1(2,NU),
     +          A2(2,NU),B(NU),BL(NU),BH(NU),ULO(NU),UHI(NU)
      INTEGER IND(N)
c
c     alpha1 = TabAab$alpha1
c     alpha2 = TabAab$alpha2
c     mu1    = TabAab$mu1
c     mu2    = TabAab$mu2
c     ka     = TabAab$ka
c     km     = TabAab$km
c     alg    = seq(from=alpha1,to=alpha2,length=ka)
c     mug    = seq(from=mu1,   to=mu2,   length=km)
      eps=4.930381d-32
	  NERR=0
      INTABMU=(mu2-mu1)/DFLOAT(km-1) 
      MUAL(2)=ALPHA0  
      DO 100 I=1,NU
      MUAL(1)=MUNIX(I)
      CALL FTITAABN(MUAL,ALPHA1,ALPHA2,MU1,MU2,ALG,KA,MUG,KM,TABB,
     +     TABA11,TABA12,TABA21,TABA22,TABA1,TABA2,B0,B0L,B0H,AA0,
     +     AL0,AH0,A0,A0L,A0H,MULOW,MUHIGH,IERR)
	  NERR=MAX0(NERR,IERR)
      B(I)=B0
      BL(I)=B0L
      BH(I)=B0H
      AA(1,1,I)=AA0(1,1)
      AA(1,2,I)=AA0(1,2)
      AA(2,1,I)=AA0(2,1)
      AA(2,2,I)=AA0(2,2)
      A(1,I)=A0(1)
      A(2,I)=A0(2)
      AL(1,1,I)=AL0(1,1)
      AL(1,2,I)=AL0(1,2)
      AL(2,1,I)=AL0(2,1)
      AL(2,2,I)=Al0(2,2)
      A1(1,I)=A0L(1)
      A1(2,I)=A0L(2)
      AH(1,1,I)=AH0(1,1)
      AH(1,2,I)=AH0(1,2)
      AH(2,1,I)=AH0(2,1)
      AH(2,2,I)=AH0(2,2)
      A2(1,I)=A0H(1)
      A2(2,I)=A0H(2)
      ULO(I)=MULOW
      UHI(I)=MUHIGH
  100 CONTINUE

      EQ1=0.D0
      EQ2=0.D0
      DO 300 I=1,N
      J=IND(I)
      MUI=MUNIX(J)
      MUX(I)=MUI
      HPX(I)=HPUNIX(J)
      HPPX(I)=HPPUNIX(J)  
      A1X(I)=A(1,J)
      A1PX(I)=(A2(1,J)-A1(1,J))/INTABMU
      CALL sB1(y(i),1,mui,alpha0,Z,1,eps)
      z1 = AA(1,1,J)*(Z(1,1)-A(1,J)) + AA(1,2,J)*(Z(1,2)-A(2,J))
      z2 = AA(2,1,J)*(Z(1,1)-A(1,J)) + AA(2,2,J)*(Z(1,2)-A(2,J))
      D = DSQRT(z1*z1 + z2*z2)
      WX(I)=DMIN1(1.D0,B(J)/D)
      CALL sB1(y(i),1,ulo(j),alpha0,ZZ,1,eps)
      z1 = AL(1,1,J)*(ZZ(1,1)-A1(1,J)) + AL(1,2,J)*(ZZ(1,2)-A1(2,J))
      z2 = AL(2,1,J)*(ZZ(1,1)-A1(1,J)) + AL(2,2,J)*(ZZ(1,2)-A1(2,J))
      D = DSQRT(z1*z1 + z2*z2)
      WXL=DMIN1(1.D0,BL(J)/D)
      CALL sB1(y(i),1,uhi(j),alpha0,ZZ,1,eps)
      z1 = AH(1,1,J)*(ZZ(1,1)-A2(1,J)) + AH(1,2,J)*(ZZ(1,2)-A2(2,J))
      z2 = AH(2,1,J)*(ZZ(1,1)-A2(1,J)) + AH(2,2,J)*(ZZ(1,2)-A2(2,J))
      D = DSQRT(z1*z1 + z2*z2)
      WXH=DMIN1(1.D0,BH(J)/D)
      WPX(I)=(WXH-WXL)/INTABMU
      EQ1=EQ1+WX(I)*WEIX(I)*(Z(1,1)-A(1,J))*X(I)*HPX(I)
      EQ2=EQ2+WX(I)*WEIX(I)*(Z(1,1)-A(1,J))*HPX(I)
 300  CONTINUE
      IF (MWRN*NERR.NE.0) CALL MESSNB(400+NERR,'FTITAABN',0)
      RETURN
      END



