C Per il caso senza regressori, mu e alpha soltanto
C Tutti gli score in una unica subroutine
      subroutine sB1(y,n,dmu,alpha,z,nk,eps)

      implicit double precision (a-h,o,q-z)
      implicit integer (i,j,p,n)

      dimension y(n), z(nk,2)

      parameter(dzero=0.0d00)
      parameter(duno=1.0d00)
      parameter(ddue=2.0d00)

C Score di mu
      den = duno+alpha*dmu
      do 20 i=1,n
        z(i,1) = y(i)/dmu - (duno+alpha*y(i))/den 

C Score di alpha
        dummy = dzero
        if (y(i).ge.ddue) then
         iyi = y(i)-1
         do 40 j = 1,iyi
            dj = j
            dummy = dummy + dj/(duno+alpha*dj)
 40       continue
        endif
        dtemp = dummy + alpha**(-2)*dlog(duno+alpha*dmu) 
     +        - dmu*(y(i)+duno/alpha)/(duno+alpha*dmu)
        if (dabs(dtemp).gt.eps) then
          z(i,2) = dtemp
        else
          z(i,2) = dzero
        endif
 20   continue
      return
      end
